package com.example.angelus9110.routes4riders.ui;

import android.app.Fragment;
import android.content.ContentValues;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.support.design.widget.Snackbar;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;

import com.example.angelus9110.routes4riders.R;
import com.example.angelus9110.routes4riders.sqlite.DbHelper;
import com.example.angelus9110.routes4riders.sqlite.UserContract;

public class DatosUpdateFragment extends Fragment implements View.OnClickListener {
    private static final String TAG = DatosActivity.class.getSimpleName();
    Button buttonAceptar;
    Button buttonNuevaMoto;
    Button buttonEliminarMoto;
    Button buttonAtras;
    TextView textMoto;
    TextView userName;
    TextView userEmail;
    Cursor usuario;
    String nombreDB;
    String emailDB;
    String marcaDB;
    String modeloDB;
    String idDB;
    String marcaElegida;
    String modeloElegido;
    String flag;
    SharedPreferences prefs;
    View view;
    private DbHelper dbHelper;

    @Override
    public View onCreateView(LayoutInflater inflater, final ViewGroup container,
                             Bundle savedInstanceState) {

        view = inflater.inflate(R.layout.fragment_datos_update, container, false);
        prefs = PreferenceManager.getDefaultSharedPreferences(getActivity());

        super.onCreate(savedInstanceState);

        //Enlazar Views
        buttonAceptar = view.findViewById(R.id.guardar_datos);
        buttonNuevaMoto = view.findViewById(R.id.nueva_moto);
        buttonEliminarMoto = view.findViewById(R.id.eliminar_moto);
        buttonAtras = view.findViewById(R.id.atras);
        textMoto = view.findViewById(R.id.modelo_moto);
        userName = view.findViewById(R.id.nombre_usuario);
        userEmail = view.findViewById(R.id.correo_usuario);

        Uri uri = UserContract.CONTENT_URI;
        usuario = getActivity().getContentResolver().query(uri, null, null, null, null);

        if (usuario.moveToFirst()) {
            do {
                idDB = usuario.getString(usuario.getColumnIndex(UserContract.Column.ID));
                nombreDB = usuario.getString(usuario.getColumnIndex(UserContract.Column.USER));
                emailDB = usuario.getString(usuario.getColumnIndex(UserContract.Column.EMAIL));
                marcaDB = usuario.getString(usuario.getColumnIndex(UserContract.Column.MARCA));
                modeloDB = usuario.getString(usuario.getColumnIndex(UserContract.Column.MODELO));
            } while (usuario.moveToNext());
        }
        usuario.close();
        userName.setText(nombreDB);
        userEmail.setText(emailDB);
        textMoto.setText(marcaDB + " " + modeloDB);


        buttonAceptar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (userName.getText().length() > 0 && textMoto.getText().length() > 0) {
                    DatosUpdateFragment.TareaUsuario task = new DatosUpdateFragment.TareaUsuario();
                    task.execute();
                    Intent intent = new Intent(getActivity().getApplicationContext(), MapsActivity.class);
                    startActivity(intent);
                } else {
                    Snackbar.make(v, R.string.error_perfil_logup, Snackbar.LENGTH_LONG).show();
                    Log.d(TAG, "El usuario o la moto no son correctos o estan vacios");
                }
            }
        });

        buttonNuevaMoto.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent nextScreen = new Intent(getActivity().getApplicationContext(), MotoActivity.class);
                startActivityForResult(nextScreen, 1000);

            }
        });

        buttonEliminarMoto.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                textMoto.setText("");
            }
        });

        buttonAtras.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                getActivity().finish();
            }
        });

        return view;
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        flag = data.getExtras().getString("flag");
        if(flag.equals("seleccionada")) {
            marcaElegida = data.getExtras().getString("marca");
            modeloElegido = data.getExtras().getString("modelo");
            Log.d(TAG, "marca " + marcaElegida);
            Log.d(TAG, "modelo " + modeloElegido);
            textMoto.setText(marcaElegida + " " + modeloElegido);
        }else{
            textMoto.setText(marcaDB + " " + modeloDB);
        }
    }

    @Override
    public void onClick(View v) {

    }

    public class TareaUsuario extends AsyncTask<Void, Void, Void> {
        @Override
        protected Void doInBackground(Void... params) {
            Log.d(TAG, "Esta entrando al doInBackground");

            Uri uri = UserContract.CONTENT_URI;

            if(marcaElegida == null && modeloElegido ==null){
                marcaElegida = marcaDB;
                modeloElegido = modeloDB;
            }

            ContentValues userValues = new ContentValues();
            userValues.put(UserContract.Column.EMAIL, userEmail.getText().toString());
            userValues.put(UserContract.Column.USER, userName.getText().toString());
            userValues.put(UserContract.Column.MARCA, marcaElegida);
            userValues.put(UserContract.Column.MODELO, modeloElegido);
            getActivity().getContentResolver().update(uri, userValues, null, null);

            return null;
        }
    }


}