package com.example.angelus9110.routes4riders.ui;

import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.TextView;

import com.example.angelus9110.routes4riders.R;
import com.example.angelus9110.routes4riders.sqlite.MotoContract;
import com.example.angelus9110.routes4riders.sqlite.UserContract;

import java.util.ArrayList;

public class MotoActivity extends AppCompatActivity implements AdapterView.OnItemSelectedListener {

    private static final String TAG = MotoActivity.class.getSimpleName();
    Button buttonAceptar;
    Spinner spinnerMarca;
    Spinner spinnerModelo;
    String marcaElegida;
    String modeloElegido;
    Cursor usuario;
    String nombreDB;
    String emailDB;
    String marcaDB;
    String modeloDB;
    String idDB;
    Cursor marcas;
    Cursor modelos;
    ArrayList<String> listaMarcas = new ArrayList<String>();
    ArrayList<String> listaModelos = new ArrayList<String>();
    View view;
    protected static final int REQUEST_CODE = 10;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_moto);

        Uri uriInitial = UserContract.CONTENT_URI;
        usuario = getContentResolver().query(uriInitial, null, null, null, null);

        if (usuario.moveToFirst()) {
            do {
                idDB = usuario.getString(usuario.getColumnIndex(UserContract.Column.ID));
                nombreDB = usuario.getString(usuario.getColumnIndex(UserContract.Column.USER));
                emailDB = usuario.getString(usuario.getColumnIndex(UserContract.Column.EMAIL));
                marcaDB = usuario.getString(usuario.getColumnIndex(UserContract.Column.MARCA));
                modeloDB = usuario.getString(usuario.getColumnIndex(UserContract.Column.MODELO));
            } while (usuario.moveToNext());
        }

        buttonAceptar = findViewById(R.id.guardar_datos);
        buttonAceptar.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (marcaElegida != null && modeloElegido != null) {
                    Intent previousScreen = new Intent(getApplicationContext(), DatosActivity.class);
                    previousScreen.putExtra("marca", marcaElegida);
                    previousScreen.putExtra("modelo", modeloElegido);
                    previousScreen.putExtra("flag", "seleccionada");
                    setResult(1000,previousScreen);
                    finish();
                } else {
                    Snackbar.make(view, getString(R.string.error_seleccion_moto), Snackbar.LENGTH_LONG).show();
                }
            }
        });

        spinnerMarca = findViewById(R.id.marca_moto);
        spinnerMarca.setOnItemSelectedListener(this);
        spinnerModelo = findViewById(R.id.modelo_moto);
        spinnerModelo.setOnItemSelectedListener(this);

        Uri uri = MotoContract.CONTENT_URI;
        String[] select = {"DISTINCT marca"};
        marcas = getContentResolver().query(uri, select, null, null, null);

        if (marcas.moveToFirst()) {
            do {
                String data = marcas.getString(marcas.getColumnIndex(MotoContract.Column.MARCA_MOTO));
                listaMarcas.add(data);
            } while (marcas.moveToNext());
        }
        marcas.close();

        ArrayAdapter<String> adapter = new ArrayAdapter<>(getApplicationContext(), android.R.layout.simple_spinner_dropdown_item, listaMarcas);
        spinnerMarca.setAdapter(adapter);
    }

    @Override
    public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
        if (listaMarcas.contains(parent.getItemAtPosition(position).toString())) {
            ((TextView) spinnerMarca.getSelectedView()).setTextColor(getResources().getColor(R.color.my_spinner_text_color));
            marcaElegida = parent.getItemAtPosition(position).toString();
            Uri uri = MotoContract.CONTENT_URI;
            String[] select = {"modelo"};
            String where = MotoContract.Column.MARCA_MOTO + " = " + "'" + spinnerMarca.getItemAtPosition(position).toString() + "'";
            modelos = getContentResolver().query(uri, select, where, null, null);
            listaModelos.clear();
            if (modelos.moveToFirst()) {
                do {
                    String data = modelos.getString(modelos.getColumnIndex(MotoContract.Column.MODELO_MOTO));
                    listaModelos.add(data);
                } while (modelos.moveToNext());
            }
            modelos.close();
            ArrayAdapter<String> adapterModelos = new ArrayAdapter<String>(getApplicationContext(), android.R.layout.simple_spinner_dropdown_item, listaModelos);
            spinnerModelo.setAdapter(adapterModelos);
        }

        if (listaModelos.contains(parent.getItemAtPosition(position).toString())) {
            ((TextView) spinnerModelo.getSelectedView()).setTextColor(getResources().getColor(R.color.my_spinner_text_color));
            modeloElegido = parent.getItemAtPosition(position).toString();
        }
    }

    @Override
    public void onNothingSelected(AdapterView<?> parent) {
        ((TextView) spinnerMarca.getSelectedView()).setTextColor(getResources().getColor(R.color.my_spinner_text_color));
    }

    @Override
    public void onBackPressed() {
        if (marcaElegida != null && modeloElegido != null) {
            Intent previousScreen = new Intent(getApplicationContext(), DatosActivity.class);
            previousScreen.putExtra("marca", "");
            previousScreen.putExtra("modelo", "");
            previousScreen.putExtra("flag", "noSeleccionada");
            setResult(1000,previousScreen);
            finish();
        } else {
            Snackbar.make(view, getString(R.string.error_seleccion_moto), Snackbar.LENGTH_LONG).show();
        }
    }
}
